Index: source/Plugins/Process/elf-core/RegisterContextPOSIXCore_x86_64.cpp
===================================================================
--- source/Plugins/Process/elf-core/RegisterContextPOSIXCore_x86_64.cpp
+++ source/Plugins/Process/elf-core/RegisterContextPOSIXCore_x86_64.cpp
@@ -1,4 +1,4 @@
-//===-- RegisterContextCoreLinux_x86_64.cpp -------------------------*- C++ -*-===//
+//===-- RegisterContextCorePOSIX_x86_64.cpp -------------------------*- C++ -*-===//
 //
 //                     The LLVM Compiler Infrastructure
 //
@@ -10,14 +10,16 @@
 #include "lldb/Core/DataExtractor.h"
 #include "lldb/Core/RegisterValue.h"
 #include "lldb/Target/Thread.h"
-#include "RegisterContextCoreLinux_x86_64.h"
+#include "RegisterContextPOSIX.h"
+#include "RegisterContextPOSIXCore_x86_64.h"
 
 using namespace lldb_private;
 
-RegisterContextCoreLinux_x86_64::RegisterContextCoreLinux_x86_64(Thread &thread,
-                                                const DataExtractor &gpregset,
-                                                const DataExtractor &fpregset)
-    : RegisterContextLinux_x86_64(thread, 0)
+RegisterContextCorePOSIX_x86_64::RegisterContextCorePOSIX_x86_64(Thread &thread,
+                                                                 RegisterInfoInterface *register_info,
+                                                                 const DataExtractor &gpregset,
+                                                                 const DataExtractor &fpregset)
+    : RegisterContextPOSIX_x86_64(thread, 0, register_info)
 {
     size_t size, len;
 
@@ -27,44 +29,70 @@
     assert(len == size);
 }
 
-RegisterContextCoreLinux_x86_64::~RegisterContextCoreLinux_x86_64()
+RegisterContextCorePOSIX_x86_64::~RegisterContextCorePOSIX_x86_64()
 {
     delete [] m_gpregset;
 }
 
 bool
-RegisterContextCoreLinux_x86_64::ReadRegister(const RegisterInfo *reg_info, RegisterValue &value)
+RegisterContextCorePOSIX_x86_64::ReadGPR()
+{
+    return m_gpregset != NULL;
+}
+
+bool
+RegisterContextCorePOSIX_x86_64::ReadFPR()
+{
+    return false;
+}
+
+bool
+RegisterContextCorePOSIX_x86_64::WriteGPR()
+{
+    assert(0);
+    return false;
+}
+
+bool
+RegisterContextCorePOSIX_x86_64::WriteFPR()
+{
+    assert(0);
+    return false;
+}
+
+bool
+RegisterContextCorePOSIX_x86_64::ReadRegister(const RegisterInfo *reg_info, RegisterValue &value)
 {
     value = *(uint64_t *)(m_gpregset + reg_info->byte_offset);
     return true;
 }
 
 bool
-RegisterContextCoreLinux_x86_64::ReadAllRegisterValues(lldb::DataBufferSP &data_sp)
+RegisterContextCorePOSIX_x86_64::ReadAllRegisterValues(lldb::DataBufferSP &data_sp)
 {
     return false;
 }
 
 bool
-RegisterContextCoreLinux_x86_64::WriteRegister(const RegisterInfo *reg_info, const RegisterValue &value)
+RegisterContextCorePOSIX_x86_64::WriteRegister(const RegisterInfo *reg_info, const RegisterValue &value)
 {
     return false;
 }
 
 bool
-RegisterContextCoreLinux_x86_64::WriteAllRegisterValues(const lldb::DataBufferSP &data_sp)
+RegisterContextCorePOSIX_x86_64::WriteAllRegisterValues(const lldb::DataBufferSP &data_sp)
 {
     return false;
 }
 
 bool
-RegisterContextCoreLinux_x86_64::UpdateAfterBreakpoint()
+RegisterContextCorePOSIX_x86_64::UpdateAfterBreakpoint()
 {
     return false;
 }
 
 bool
-RegisterContextCoreLinux_x86_64::HardwareSingleStep(bool enable)
+RegisterContextCorePOSIX_x86_64::HardwareSingleStep(bool enable)
 {
     return false;
 }
Index: source/Plugins/Process/elf-core/RegisterContextPOSIXCore_x86_64.h
===================================================================
--- source/Plugins/Process/elf-core/RegisterContextPOSIXCore_x86_64.h
+++ source/Plugins/Process/elf-core/RegisterContextPOSIXCore_x86_64.h
@@ -1,24 +1,27 @@
-//===-- RegisterContextCoreLinux_x86_64.h ----------------------*- C++ -*-===//
+//===-- RegisterContextCorePOSIX_x86_64.h ----------------------*- C++ -*-===//
 //
 //                     The LLVM Compiler Infrastructure
 //
 // This file is distributed under the University of Illinois Open Source
 // License. See LICENSE.TXT for details.
 //
 //===---------------------------------------------------------------------===//
 
-#ifndef liblldb_RegisterContextCoreLinux_x86_64_H_
-#define liblldb_RegisterContextCoreLinux_x86_64_H_
+#ifndef liblldb_RegisterContextCorePOSIX_x86_64_H_
+#define liblldb_RegisterContextCorePOSIX_x86_64_H_
 
-#include "Plugins/Process/POSIX/RegisterContextLinux_x86_64.h"
+#include "Plugins/Process/POSIX/RegisterContextPOSIX_x86_64.h"
 
-class RegisterContextCoreLinux_x86_64: public RegisterContextLinux_x86_64
+class RegisterContextCorePOSIX_x86_64 :
+    public RegisterContextPOSIX_x86_64
 {
 public:
-    RegisterContextCoreLinux_x86_64 (lldb_private::Thread &thread, const lldb_private::DataExtractor &gpregset,
+    RegisterContextCorePOSIX_x86_64 (lldb_private::Thread &thread,
+                                     RegisterInfoInterface *register_info,
+                                     const lldb_private::DataExtractor &gpregset,
                                      const lldb_private::DataExtractor &fpregset);
 
-    ~RegisterContextCoreLinux_x86_64();
+    ~RegisterContextCorePOSIX_x86_64();
 
     virtual bool
     ReadRegister(const lldb_private::RegisterInfo *reg_info, lldb_private::RegisterValue &value);
@@ -40,13 +43,22 @@
 
 protected:
     bool
-    ReadFPR()
-    {
-        assert(0);
-    }
+    ReadGPR();
+
+    bool
+    ReadFPR();
+
+    bool
+    WriteGPR();
+
+    bool
+    WriteFPR();
+
+    bool ReadRegister(const unsigned reg, lldb_private::RegisterValue &value) { return false; }
+    bool WriteRegister(const unsigned reg, const lldb_private::RegisterValue &value) { return false; }
 
 private:
     uint8_t *m_gpregset;
 };
 
-#endif // #ifndef liblldb_RegisterContextCoreLinux_x86_64_H_
+#endif // #ifndef liblldb_RegisterContextCorePOSIX_x86_64_H_
Index: source/Plugins/Process/elf-core/ThreadElfCore.cpp
===================================================================
--- source/Plugins/Process/elf-core/ThreadElfCore.cpp
+++ source/Plugins/Process/elf-core/ThreadElfCore.cpp
@@ -16,8 +16,9 @@
 
 #include "ThreadElfCore.h"
 #include "ProcessElfCore.h"
-#include "RegisterContextCoreFreeBSD_x86_64.h"
-#include "RegisterContextCoreLinux_x86_64.h"
+#include "RegisterContextLinux_x86_64.h"
+#include "RegisterContextFreeBSD_x86_64.h"
+#include "RegisterContextPOSIXCore_x86_64.h"
 
 using namespace lldb;
 using namespace lldb_private;
@@ -88,10 +89,10 @@
                 switch (arch.GetTriple().getOS())
                 {
                     case llvm::Triple::FreeBSD:
-                        m_thread_reg_ctx_sp.reset(new RegisterContextCoreFreeBSD_x86_64 (*this, m_gpregset_data, m_fpregset_data));
+                        m_thread_reg_ctx_sp.reset(new RegisterContextCorePOSIX_x86_64 (*this, new RegisterContextFreeBSD_x86_64(), m_gpregset_data, m_fpregset_data));
                         break;
                     case llvm::Triple::Linux:
-                        m_thread_reg_ctx_sp.reset(new RegisterContextCoreLinux_x86_64 (*this, m_gpregset_data, m_fpregset_data));
+                        m_thread_reg_ctx_sp.reset(new RegisterContextCorePOSIX_x86_64 (*this, new RegisterContextLinux_x86_64(), m_gpregset_data, m_fpregset_data));
                         break;
                     default:
                         if (log)
